<template>
  <div class="column is-8-tablet is-offset-2-tablet is-6-desktop is-offset-3-desktop is-6-widescreen is-offset-3-widescreen is-4-fullhd is-offset-4-fullhd">
    <div class="column has-text-centered">
      <p class="title is-3">
        Login
      </p>
      <p class="subtitle is-5">
        Don't have account?
        <nuxt-link to="/signup">
          Sign Up
        </nuxt-link>
      </p>
    </div>

    <div class="column">
      <LoginForm :processingLogin="processingLogin" :onValid="doLogin" />
    </div>

    <div class="column has-text-centered">
      <p class="subtitle is-5">
        <nuxt-link to="/reset_password">
          Forgot password?
        </nuxt-link>
      </p>
    </div>
  </div>
</template>

<script>
import LoginForm from '~/components/LoginForm'

export default {
  components: { LoginForm },

  data () {
    return {
      processingLogin: false
    }
  },

  methods: {
    doLogin ({ email, password }) {
      this.processingLogin = true
      const loginInfo = { email, password }

      this.$auth.loginWith('local', { data: loginInfo })
        .then(() => {
          this.$store.dispatch('snackbar/setSnackbar', { text: 'Thanks for signing in, ' + this.$auth.user.name, type: 'is-success' })
          this.$router.push('/')
        })
        .catch((error) => {
          try {
            if (error.response.data._error !== undefined) {
              this.$store.dispatch('snackbar/setSnackbar', { text: error.response.data._error, type: 'is-danger' })
            } else {
              this.$store.dispatch('snackbar/setSnackbar', { text: 'Invalid operation', type: 'is-danger' })
            }
          } catch {
            this.$store.dispatch('snackbar/setSnackbar', { text: 'Problem in signing in. Please try after sometime', type: 'is-danger' })
          }
          this.processingLogin = false
        })
    }
  }
}
</script>
